<?php

namespace Schaffen\Core\Form\Models;


use Illuminate\Database\Eloquent\Model;
use Schaffen\Core\Visitation\Models\VisitationReason;
use Schaffen\ServiceOrder\ServiceOrder\Models\ServiceOrder;

class Form extends Model
{
    protected $connection = 'dynamicdb';
    protected $table = "cadastro.formulario";
    protected $primaryKey = "form_codigo";
    protected $fillable = [
        "form_descricao",
        "form_status",
        "form_nome"
    ];


    public function form_fields()
    {
        return $this->hasMany(FormField::class, 'cafo_fk_form_codigo');
    }

//    public function fields()
//    {
//        return $this->hasManyThrough(
//            Field::class,
//            FormField::class,
//            'cafo_fk_form_codigo',
//            'cam_codigo',
//            'form_codigo',
//            'cafo_fk_cam_codigo'
//        )->orderBy('cafo_sequencial', 'asc');
//    }
    public function fields()
    {
        return $this->belongsToMany(
            Field::class,
            FormField::class,
            'cafo_fk_form_codigo',
           'cafo_fk_cam_codigo',
            'form_codigo',
            'cam_codigo',

        )->orderBy('cafo_sequencial', 'asc')
           ->select(['campo.*','cafo_fk_form_codigo','cafo_fk_cam_codigo','cafo_sequencial']);
    }

    public function association()
    {
        return $this->hasMany(FormAssociation::class, 'foa_fk_form_codigo');
    }


    public function service_order()
    {
        return $this->hasManyThrough(
            ServiceOrder::class,
            FormAssociation::class,
            'foa_codigo', 'os_codigo', 'form_codigo', 'foa_formeavel_codigo')->where('foa_formeavel_tipo',
            'service-order');
    }

    public function visitationReason()
    {
        return $this->hasManyThrough(
            VisitationReason::class,
            FormAssociation::class,
            'foa_codigo', 'mov_codigo', 'form_codigo', 'foa_formeavel_codigo')->where('foa_formeavel_tipo',
            'visitation-reason');
    }

    public function formGrouping()
    {
        return $this->hasManyThrough(
            FormGrouping::class,
            FormAssociation::class,
            'foa_codigo', 'foag_codigo', 'form_codigo', 'foa_formeavel_codigo')->where('foa_formeavel_tipo',
            'form-grouping');
    }
}
