<?php

namespace Schaffen\Core\Form\Services;

use Schaffen\Core\Form\Models\Form;

class ManipulateForm
{
   /**
    * @param $campos
    * @return array|bool
    */
   public function getFieldsId($campos)
   {
      if (!isset($campos)) return false;
      if (!is_array($campos)) {
         $campos = [$campos];
      }
      $ids = array();
      $without_seq = array();
      foreach ($campos as $campo) {
         $id = $this->getId($campo);
         if (is_numeric($id))
            if (!is_array($campo) || !isset($campo['cafo_sequencial'])) {
               $without_seq[$id] = ["created_at" => now(), "created_by" => auth()->user()->usu_codigo];
            } else
               $ids[$id] = ["cafo_sequencial" => $campo['cafo_sequencial'], "created_at" => now(), "created_by" => auth()->user()->usu_codigo];
      }
      foreach ($without_seq as $key=>$value){
         $max = collect($ids)->max("cafo_sequencial") ?? 0;
         $ids[$key] = array_merge($value, ["cafo_sequencial" => ++$max]);
      }

      return $ids;
   }

   /**
    * @param $campo
    * @return int|string|bool
    */
   protected function getId($campo = null)
   {
      if (is_array($campo)) return $campo['cam_codigo'];
      return $campo ?? false;
   }

   /**
    * @param Form $form
    * @param array $fields
    * @return mixed
    */
   public function sync(Form $form, array $fields)
   {
      $form->fields()->detach();
      return $form->fields()->sync($fields);
   }
}