<?php


namespace Schaffen\Core\Person\Managers;


use Freelabois\LaravelQuickstart\Extendables\ManipulationManager;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Support\Facades\DB;
use Schaffen\Core\Person\Models\Contact;
use Schaffen\Core\Person\Repositories\ContactRepository;

class ContactManager extends ManipulationManager
{
    public function __construct(ContactRepository $repository)
    {
        parent::__construct($repository);
    }

    public function storeOrUpdate($values, int $id = null, $relations = []): Contact
    {
        return DB::transaction(function () use ($values, $id, $relations) {
            if (isset($values['peco_padrao']) && $values['peco_padrao'] === 1) {
                $pes_codigo = null;
                if (isset($values['peco_fk_pes_codigo'])) {
                    $pes_codigo = $values['peco_fk_pes_codigo'];
                }
                if (!$pes_codigo && $id) {
                    /** @var int|null $pes_codigo */
                    $pes_codigo = $this->repository->setSelect(['peco_fk_pes_codigo'])
                        ->find($id)->peco_fk_pes_codigo;
                }
                /** @var Builder $query */
                $query = $this->repository->newQuery();
                $query->where('peco_fk_pes_codigo', $pes_codigo)
                    ->where('peco_padrao', '=', 1)
                    ->update(['peco_padrao' => 0]);
            }
            return parent::storeOrUpdate($values, $id, $relations);
        });
    }

}
